# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead

%if "%{?rhel}" == "6"
%if %with mead
%bcond_with maven
%bcond_with repolib
%else
%bcond_without maven
%bcond_without repolib
%endif
%else
%bcond_with maven
%bcond_with repolib
%endif

%if 0
%define repodir %{_javadir}/repository.jboss.com/jline/jline/%{meadversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src
%endif

%define section free

%global meadversion %{version}-redhat-2

%define maven_version 0.9.94-redhat-2

Name:           jline-eap6
Version:        0.9.94
Release:        10.GA_redhat_2%{?dist}.4
Epoch:          0
Summary:        Java library for reading and editing user input in console applications
License:        LGPLv2+
URL:            http://jline.sf.net/
Group:          Development/Java

%if %with mead
Source100: jline-jline-0.9.94-redhat-2-sources.zip
Source101: jline-jline-0.9.94-redhat-2-patches.zip
Source102: jline-0.9.94-redhat-2-sources.jar
Source103: jline-0.9.94-redhat-2.pom
Source104: jline-0.9.94-redhat-2-javadoc.jar
Source105: jline-0.9.94-redhat-2.jar
%endif

%if 0
Source0:        http://download.sourceforge.net/sourceforge/jline/jline-0.9.94.zip
Source1:        CatalogManager.properties
Source2:        jline-build.xml
%endif
%if %without mead
# git clone git://git.app.eng.bos.redhat.com/jline.git
# tar cjf jline-0.9.94.tar.bz2 jline
Source0:	jline-0.9.94.tar.bz2
Source1:        CatalogManager.properties
Source2:        jline-build.xml
#Patch to set scope of junit test
Patch0:         jline-pom_xml.patch
Patch1:         jline-vman.patch

BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:  xml-commons-resolver
BuildRequires:  ant >= 0:1.6
BuildRequires:  maven2
BuildRequires:  maven2-plugin-deploy
BuildRequires:  jboss-eap6-boms
BuildRequires:  jboss-parent
%if %with maven
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:	maven2-plugin-release
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
%endif
%endif

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JLine is a java library for reading and editing user input in console
applications. It features tab-completion, command history, password
masking, customizable keybindings, and pass-through handlers to use to
chain to other console applications.

%package        -n jline
Summary:        Java library for reading and editing user input in console applications
Group:          Development/Libraries/Java

Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils

%description    -n jline
JLine is a java library for reading and editing user input in console
applications. It features tab-completion, command history, password
masking, customizable keybindings, and pass-through handlers to use to
chain to other console applications.

%if %without mead
%package        -n jline-demo
Summary:        Demos for jline
Group:          Development/Documentation

Requires:       jpackage-utils

%description    -n jline-demo
Demonstrations and samples for jline.

%package        -n jline-javadoc
Summary:        Javadoc for jline
Group:          Development/Documentation

Requires:       jpackage-utils

%description    -n jline-javadoc
Javadoc for jline.
%endif

%if %with repolib
%package -n jline-repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description -n jline-repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
# BEWARE: The jar file META-INF is not under the subdir
%if %without mead
%setup -q -c
cp -pr jline-%{version}/* .
rm -r jline-%{version}
find -type f -name '*.jar' | xargs -t rm

# Use locally installed DTDs
mkdir -p build
cp -p %{SOURCE1} build/CatalogManager.properties
cp -p %{SOURCE2} src/build.xml

# Apply vman patch to pom
%patch1 -p1 -b .orig

%patch0 -p0

%if %without maven
perl -p -i -e 's|^.*<attribute name="Class-Path".*||' build.xml
%endif
%endif

%build
%if %without mead
mkdir -p native

# Use locally installed DTDs
export CLASSPATH=`pwd`/build
cd src/
%if %with maven
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mvn-jpp \
        -e \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        -DaltDeploymentRepository=oss-releases::default::file://`pwd`/maven2-brew \
        javadoc:aggregate deploy
%else
export CLASSPATH=`pwd`/target/classes:`pwd`/target/test-classes
export OPT_JAR_LIST=:
ant -Dbuild.sysclasspath=only jar javadoc
%endif
%endif

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
%if %without mead
%if %without maven
install -p -m 644 src/target/jline.jar %{buildroot}%{_javadir}/jline-%{meadversion}.jar
%else
cp -p src/target/jline-%{meadversion}.jar %{buildroot}%{_javadir}/jline-%{meadversion}.jar
%endif
%else
%{__cp} -p %{_sourcedir}/jline-%{meadversion}.jar %{buildroot}%{_javadir}/jline-%{meadversion}.jar
%{__cp} -p %{_sourcedir}/jline-%{meadversion}-sources.jar %{buildroot}%{_javadir}/jline-%{meadversion}-sources.jar
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{meadversion}*; do ln -s ${jar} ${jar/-%{meadversion}/}; done)

# Alternative JAR location
install -d -m 755 %{buildroot}%{_javadir}/%{name}
%if %without mead
%if %without maven
install -p -m 644 src/target/jline.jar %{buildroot}%{_javadir}/%{name}/jline-%{meadversion}.jar
%else
cp -p src/target/jline-%{meadversion}.jar %{buildroot}%{_javadir}/%{name}/jline-%{meadversion}.jar
%endif
%else
%{__cp} -p %{_sourcedir}/jline-%{meadversion}.jar %{buildroot}%{_javadir}/%{name}/jline-%{meadversion}.jar
%{__cp} -p %{_sourcedir}/jline-%{meadversion}-sources.jar %{buildroot}%{_javadir}/%{name}/jline-%{meadversion}-sources.jar
%endif
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{meadversion}*; do ln -sf ${jar} ${jar/-%{meadversion}/}; done)

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
%if %without mead
# Use patched pom.xml file
cp -p src/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-jline.pom
%else
%{__cp} -p %{_sourcedir}/jline-%{meadversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-jline.pom
%endif
%add_to_maven_depmap jline jline %{meadversion} JPP jline

# javadoc
%if %without mead
install -d -m 755 %{buildroot}%{_javadocdir}/jline-%{version}
%if %without maven
cp -pr src/target/site/apidocs/* %{buildroot}%{_javadocdir}/jline-%{version}
%else
cp -pr src/target/site/apidocs/* %{buildroot}%{_javadocdir}/jline-%{version}
%endif
ln -s jline-%{version} %{buildroot}%{_javadocdir}/jline
%endif

%if %with repolib
%if %without maven
%{_bindir}/mvn-jpp deploy:deploy-file \
	-DgroupId=jline \
	-DartifactId=jline \
	-Dversion=%{meadversion} \
	-Dpackaging=jar \
	-Dfile=%{buildroot}%{_javadir}/jline-%{meadversion}.jar \
	-DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-jline.pom \
	-Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
	-DrepositoryId=jboss-releases
%{_bindir}/mvn-jpp deploy:deploy-file \
        -DgroupId=jline \
        -DartifactId=jline \
        -Dversion=%{meadversion} \
        -Dpackaging=pom \
        -Dfile=%{buildroot}%{_datadir}/maven2/poms/JPP-jline.pom \
        -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-jline.pom \
        -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
        -DrepositoryId=jboss-releases
# FIXME
rm -Rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/jline/jline/%{version}
rm -Rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/jline/jline/1.0.1
%else
mkdir -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
cp -pr src/maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif
%endif

%clean
rm -rf %{buildroot}

%post -n jline
%update_maven_depmap

%postun -n jline
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*/%{name}
%{_javadir}*/%{name}/jline.jar
%{_javadir}*/%{name}/jline-%{meadversion}.jar
%{_javadir}*/%{name}/jline-sources.jar
%{_javadir}*/%{name}/jline-%{meadversion}-sources.jar

%files -n jline
%defattr(0644,root,root,0755)
%{_javadir}*/jline.jar
%{_javadir}*/jline-%{meadversion}.jar
%{_javadir}*/jline-sources.jar
%{_javadir}*/jline-%{meadversion}-sources.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%if %without mead
%files -n jline-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/jline-%{version}
%{_javadocdir}/jline
%endif

%if %with repolib
%files -n jline-repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:0.9.94-10.GA_redhat_2.4
- Rebuild for MD5

* Mon Aug 20 2012 Paul Gier <pgier@redhat.com> - 0:0.9.94-9.GA_redhat_2.4
- Update pom patch for eap 6.0.1

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:0.9.94-9.GA_redhat_2.3
- Rebuild unsigned

* Thu Aug 09 2012 Fernando Nasser <fnasser@redhat.com> - 0:0.9.94-9.GA_redhat_2.2
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:0.9.94-9.GA_redhat_1.1
- Rebuild using cache signing

* Wed Jul 18 2012 Martha Benitez <mbenitez@redhat.com> - 0:0.9.94-9.GA_redhat_1
- Build in MEAD

* Fri May 11 2012 David Walluck <dwalluck@redhat.com> 0:0.9.94-8
- fix broken build
- fix broken maven support
- fix bad maven deploy
- fix incorrect requires in packages
- remove gcj support
- fix repolib file ownership

* Wed Apr 18 2012 Permaine Cheung <pcheung@redhat.com> - 0:0.9.94-7.GA_redhat_1
- Update vman patch and use patch instead of new pom file, update pom patch
- Fix Release: tag

* Thu Mar 29 2012 Permaine Cheung <pcheung@redhat.com> - 0:0.9.94-6_redhat_1.5
- Move update_maven_depmap to the post and postun section of jline subpackage

* Wed Mar 21 2012 Fernando Nasser <fnasser@redhat.com> - 0:0.9.94-6_redhat_1.4
- Rebuild with a -eap6 suffix to avoid conflict with RHEL-6 base

* Fri Feb 03 2012 Martha Benitez <mbenitez@redhat.com> - 0:0.9.94-6_redhat_1.3
- Rebuild

* Fri Sep 02 2011 Martha Benitez <mbenitez@redhat.com> 0:0.9.94-6_redhat_1.2
- Use modified pom.xml from vman

* Fri Sep 02 2011 Martha Benitez <mbenitez@redhat.com> 0:0.9.94-6_redhat_1.1
- Rebuild

* Mon Aug 22 2011 Yong Yang <yyang@redhat.com> 0:0.9.94-6_redhat_1
- Build for Werewolf

* Mon May 30 2011 Yong Yang <yyang@redhat.com> 0:0.9.94-5
- Fix repodir

* Mon May 30 2011 Yong Yang <yyang@redhat.com> 0:0.9.94-4
- Add repolib
- Patch pom.xml to set scope of junit test

* Sun Sep 19 2010 Hui Wang <huwang@redhat.com> 0:0.9.94-3
- Add BR ant
- Change jline-0.9.94.jar to jline.jar in install section
- Build with ant

* Fri Nov 21 2008 Yong Yang <yyang@redhat.com> 0:0.9.94-2
- import into brew, update maven2-plugin-*, update pom

* Thu Oct 02 2008 David Walluck <dwalluck@redhat.com> 0:0.9.94-1
- 0.9.94

* Thu Jul 12 2007 Ralph Apel <r.apel at r-apel.de> - 0:0.9.9.1-1jpp
- Upgrade to 0.9.9.1
- Add pom and depmap frag

* Tue Feb 27 2007 Ralph Apel <r.apel at r-apel.de> - 0:0.9.9-2jpp
- Add gcj_support option
- Optionally build without maven
- Add some maven2-plugins as BR

* Thu May 04 2006 Alexander Kurtakov <akurtkov at gmail.com> - 0:0.9.9-1jpp
- Upgrade to 0.9.9

* Thu May 04 2006 Ralph Apel <r.apel at r-apel.de> - 0:0.9.5-1jpp
- Upgrade to 0.9.5
- First JPP-1.7 release

* Mon Apr 25 2005 Fernando Nasser <fnasser@redhat.com> - 0:0.9.1-1jpp
- Upgrade to 0.9.1
- Disable attempt to include external jars

* Mon Apr 25 2005 Fernando Nasser <fnasser@redhat.com> - 0:0.8.1-3jpp
- Changes to use locally installed DTDs
- Do not try and access sun site for linking javadoc

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:0.8.1-2jpp
- Rebuild with ant-1.6.2

* Mon Jan 26 2004 David Walluck <david@anti-microsoft.org> 0:0.8.1-1jpp
- release
